package org.ids_mannheim;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.stream.IntStream;

public class WorkerNodePool {
    ArrayList<String> execPool = new ArrayList<String>();
    ArrayList<String> hostPool = new ArrayList<String>();
    public final int size;

    public String getExec(int i) {
        return execPool.get(i);
    }

    public String getHost(int i) {
        return hostPool.get(i);
    }

    private String hostToExec(String host) {
        if(host.equals("") || host.matches("local")) {
            return "nice -5 ";
        } else {
            return " ssh " + host + " nice -5 ";
        }
    }

    public WorkerNodePool(String description) {
        Arrays.stream(description.split(", *")).forEachOrdered(s -> {
            String[] single = s.split("\\s*[*]\\s*");
            final String host;
            int procs = 0;
            if (single.length == 1) {
                procs = 1;
                host = single[0];
            } else if (single.length == 2) {
                procs = Integer.valueOf(single[0]);
                host = single[1];
            } else {
                host = "";
                System.err.println("ERROR: Wrong worker node format: " + s);
                System.exit(-1);
            }
            IntStream.range(0, procs).forEach(u -> {
                hostPool.add(host);
                execPool.add(hostToExec(host));
            });

        });
        size = hostPool.size();
    }
}
